pipeline {
    agent any
    tools {
        'org.jenkinsci.plugins.docker.commons.tools.DockerTool' 'docker'
    }
    environment {
        PROJECT_CONFIG_VERSION = readMavenPom().getVersion()
        PROJECT_CONFIG_ARTIFACT_ID = readMavenPom().getArtifactId()
        PROJECT_CONFIG_GROUP_ID= readMavenPom().getGroupId()
    }
    stages {
            stage('Checkout') {
                steps {
                    checkout scm
                }
            }
            /* stage('Tests'){
                steps{
                     *//* withMaven(jdk: 'Jdk11', maven: 'maven_3.6.3') {
                        sh 'mvn clean test'
                    } *//*
                }
            } */
            stage('Packaging'){
                steps{
                    withMaven(jdk: 'Jdk11', maven: 'maven_3.6.3') {
                        sh 'mvn clean package -DskipTests'
                    }
                }
            }
            stage('Image docker dev en Construction...'){
                when{
                  branch 'develop'
                }
                steps{
                    script{
                        withDockerRegistry(credentialsId: 'auth-gitlab', toolName: 'docker', url: 'https://registry.gitlab.com') {
                            sh label: 'build image', script: 'docker build -t registry.gitlab.com/agrifrikacoin/${PROJECT_CONFIG_ARTIFACT_ID}:${PROJECT_CONFIG_VERSION} --build-arg JAR_FILE=target/${PROJECT_CONFIG_ARTIFACT_ID}-${PROJECT_CONFIG_VERSION}.jar .'
                            sh label: 'push image to registry', script: 'docker push registry.gitlab.com/agrifrikacoin/${PROJECT_CONFIG_ARTIFACT_ID}:${PROJECT_CONFIG_VERSION}'
                            sh label: 'tag image', script: 'docker tag registry.gitlab.com/agrifrikacoin/${PROJECT_CONFIG_ARTIFACT_ID}:${PROJECT_CONFIG_VERSION} registry.gitlab.com/agrifrikacoin/${PROJECT_CONFIG_ARTIFACT_ID}:develop'
                            sh label: 'push image latest to registry', script: 'docker push registry.gitlab.com/agrifrikacoin/${PROJECT_CONFIG_ARTIFACT_ID}:develop'
                        }
                    }
                }
            }
            stage('Image docker dev deployment'){
                 when{
                    branch 'develop'
                 }
                 steps{
                    script {
                        withDockerRegistry(credentialsId: 'auth-gitlab', toolName: 'docker', url: 'https://registry.gitlab.com') {
                            sh label: 'Deploy ms-user in dev', script: 'docker stack deploy --with-registry-auth --compose-file src/main/docker/docker-ms-user-dev.yml devops';
                        }
                    }
                }
            }
    }
    post{
        always {
            script {
                if (getContext(hudson.FilePath)) {
                    deleteDir()
                }
            }
        }
    }
}